*************************************************************************************************************
*** GUID - Global Unique IDentifier generator,  () Dmitri Bayanov, 1996, dbrad32@mail.ru ***
*** since Nov 19, 2001 new algorithm is: TimeStamp+id_PC+RandomCode (vs. TimeStamp+id_PC 
*** last update Nov 18, 2000 (TimFromGuid is added)
*************************************************************************************************************
*** Function GUID() - returns 10-bytes unique value (or 8-bytes by simplificated method) 
*** GUID() - function from Time (with a speed of response no less 0,1 ms), session and PC code
*** Also DatFromGuid() is available - recovers DATE from GUID value (as a date)
*** TimFromGuid() is available - recovers TIME from GUID value (as a string)
*** SecFromGuid() is available - recovers Seconds since midnight creation date from GUID value (as a string)
*** At the begining of your app You should call  IniGenGuid() - to initialize GUID generator
*** Attn: primary key field is recommended to create with a NOCPTRANS parameter
*************************************************************************************************************



************************************* TEST ****************************************************************
*** Test it - run this file
Local cBuf

* GUID generator initialize
 =IniGenGuid() 

* getting of GUID value
 cBuf=GUID() 

* test message
 =MessageBox(;
            "There are three GUID values: "+chr(10)+chr(13)+chr(10)+chr(13)+;
             cBuf+chr(10)+chr(13)+;
             Guid()+chr(10)+chr(13)+;
             Guid()+chr(10)+chr(13)+;
             chr(10)+chr(13)+;
            "There is a DATE, recovered from GUID: "+chr(10)+chr(13)+chr(10)+chr(13)+; 
              DTOC(DatFromGuid(cBuf))+chr(10)+chr(13)++chr(10)+chr(13)+;
            "There is a TIME,  recovered from GUID: "+chr(10)+chr(13)++chr(10)+chr(13)+;
              Alltrim(TimFromGuid(cBuf))))

Return
******************************** END OF TEST ***********************************************************




*** You have to to include the next functions code into your program code:

*************************************************************************************************
*** GUID generator initialization 
Function IniGenGuid
Public HDD_id_, UniString_, nd96s_, nd96d_, nStartDate_ && counters
Local cBuf
 nStartDate_ = VAL(SYS(11,CTOD("01/01/2000"))) && starting counter date
 nd96s_=0
 nd96d_=0
 *** Character chain loading - for hight-numeric number imaging
 UniString_=GetUniString() && save string as a public variable
 nd96s_=TickCount() && triggering last tick value
** PC id consists of HDD id + NETWORK name + HDD size, then converted in 2-bytes string
** (Thanks to Benn Kjaer for GetVolInfo function) 
HDD_id_=PADR(NumToB(Val(sys(2007,GetVolInfo()+sys(0)+sys(2020)))/3),2,'*') && CheckSum idPc - 2 bytes (max n=65000/3)
=Rand(-1) && ini Random generator via system clock 
RETURN

*********************************************************************************************************
*** The main function. To obtain the unique GUID value = TimeStamp+id_PC+RandomCode
*** 10-bytes GUID - more reliable function (vs. 8-bytes simplificated function - see below)
Function GUID
* 6bytes of TimeStamp with Counique Counters (the main value part)
* 2bytes of Computer id (for sinchronized getting GUID on several computers)
* 2bytes of Random code (for the case of system clock shift)
Return PADR(PADL(NumtoB(TickCountn()),6)+HDD_id_+PADR(NumToB(RAND()*10**4),2,'*'),10,'!')

/*
* Use this function for getting 8-byte GUID versus aboved GUID() for 10-bytes value
*********************************************************************************************************
*** The main function. To obtain the unique GUID value = TimeStamp+RandomCode
*** 8-bytes GUID - simplificated method without id_PC 2-bytes code
Function GUID
* 6bytes of TimeStamp with Counique Counters (the main value part)
* 2bytes of Random code (for the case of system clock shift)
Return PADR(PADL(NumtoB(TickCountn()),6)+PADR(NumToB(RAND()*10**4),2,'*'),8,'!')
*/


*********************************************************************************************************
*** To recover decimal number from GUID 
* (ticks + 2position for midnight seconds + 2 position for additional co-unique counter)
Function NumFromGuid(cB)
RETURN BTONum(SUBSTR(cb,1,6))


********************************************************************************************
* To recover the date from Guid value
Function DatFromGuid(cGuidValue)
Local nTick, dDate
nTick=BTONum(ALLTRIM(SUBSTR(cGuidValue,1,6)))
nTick=nTick/100 && trim 2 position by additional counique counter 
dDate=INT(nTick/8640000) && days
dDate=CTOD(SYS(10,dDate+nStartDate_))
RETURN dDate

***********************************************
* To Recover Number of seconds since midnight
Function SecFromGuid(cGuidValue)
Local nSec, nDates
nSec=BTONum(ALLTRIM(SUBSTR(cGuidValue,1,6))) && get total number of ticks
nSec=nSec/100  && trim 2 position of additional counique counter 
nDates=INT(nSec/8640000) && days
nSec=nSec - nDates*8640000  && minus days
nSec=nSec/100 && for integer seconds
Return nSec

***********************************************
* To Recover Time of Guid create date (to get string)
Function TimFromGuid(cGuidValue)
Local nSec, cTim, cHour, cMin, cSec
nSec=SecFromGuid(cGuidValue)
cHour=INT(nSec/3600)
cMin=INT((nSec-cHour*3600)/60)
cSec=nSec-cHour*3600-cMin*60
cHour=PADL(ALLTRIM(STR(cHour,2,0)),2,"0")
cMin=PADL(ALLTRIM(STR(cMin,2,0)),2,"0")
cSec=PADL(ALLTRIM(STR(cSec,5,2)),5,"0")
cTim=cHour+":"+cMin+":"+cSec
Return cTim

***************************************************************************************
*** Unique character chain building as a large base of a numeric system
Function GetUniString
Local cUniS,ni
    && cUnis - array to image the digits in a large base == LEN(cInis)
    && removed the next chars: [0-34]  '"[]&   (39,34,91,93) 
    *** compiling the array
            cUnis=chr(35)+chr(36)+chr(37) && +chr(38) - "&"
   For ni=40 to 90
       cUniS=cUniS+chr(ni)
   EndFor
            cUniS=cUniS+chr(92)
   For ni=94 to 126
       cUniS=cUniS+chr(ni)
   EndFor
   For ni=192 to 255
       cUniS=cUniS+chr(ni)
   EndFor
Return cUniS


*************************************************************************************************
*** To get the number of ticks since nStartDate_  
* (with accuracy = 10 ms, 'couse NT not allows better) 
* 6 byte - it's enough to store the ticks within 20 years 
* nStartDate_ - days number of days till nStartDate_ (01.01.2000)
Function TickCount
return int(((val(sys(11,date())) - nStartDate_))*8640000+seconds()*100)

*****************************************************************************************************
*** To obtain the unique counter value in ticks - TickCount value + additional counique counter
* Within current tick period more than one value call may be demanded
* so we should create additional counter. For further we can increase it capacity more 99
Function TickCountN
Local nNew,nNewS
 nNewS=TickCount()
  IF nNewS==nd96s_ && we are in a current tick while circle 
    IF nd96d_==99 && counter is exceeded - we'll waiting for a new tick
       DO WHILE nNewS==nd96s_
         nNewS=TickCount()
       ENDDO
      nd96d_=0
    ELSE
      nd96d_=nd96d_+1 && we have a spare counter value - increment it
    ENDIF  
  ELSE && new tick
    nd96d_=0  
  ENDIF
       nNew=nNewS*100+nd96d_  && new id getting
       nd96s_=nNewS
return (nNew)


******************************************************************************************************
*** To convert decimal number into number with other base (as length of UniString_)
* As a matter of fact, it's a packing of number in compact string value
* Used digit images are stored in UniString_, keeping ascending order in ASC values
* (c) Dm.Bayanov 1997
* (similar native VFP BinToC() function terminates when exceeds 9 digit)
* reversal converstion will - BtoNum
*** Examples of different Base of Numeric System imagination
*UniString_="01" - binary base
*UniString_="0123456789" - decimal base 10
*UniString_="0123456789ABCDEF" - hexagonal base
*UniString_="01234567890ABCDEFGHIJKLMNOP......CHR(255)" - base ~ 150
Function NumtoB(nNum)
Local cBuf,ni,nOst,nTale,nOsn,nVes, nNum, nLen, cUniStr
cBuf=""
nOst=0
nTale=0
nLen=1
cUniStr=UniString_
*** Base = nOsn
nOsn=Len(cUniStr)&&-1 && visual digits array
*** Getting the number of numeric grade in final number (ex.999>123)
DO WHILE .T.
    nOst=nOst+(nOsn-1)*nOsn**(nLen-1)
 IF nOst >= nNum
   EXIT
 ENDIF
  nLen=nLen+1
ENDDO
   FOR ni=1 TO nLen
     nOst=nNum-nTale
     * the weight of every ni Grade can have the value since minor character till major in UniString_
     nVes=INT(nOst/nOsn**(nLen-ni))
      * current rest value right to current digit grade
     nTale=nTale+nVes*nOsn**(nLen-ni)
         *  exstracting digital character corresponding grade weight from UniStr
         * nVes+1 for the sake of  getting nVes==0 character
        cBuf=cBuf+SUBSTR(cUniStr,nVes+1,1)
   NEXT
RETURN cBuf


************************************************
** Reverse string conversation into decimal value
Function BtoNum(cB)
Local ni,nj,nOst,nk,nOsn,cCim,cUniStr
nOst=0
cUniStr=UniString_
nOsn=LEN(cUniStr)
FOR ni=1 TO LEN(cB)
  cCim=SUBSTR(cb,LEN(cb)-ni+1,1)
  nk=AT(cCim,cUniStr)-1
  nOst=nOst+nk*(nOsn**(ni-1))
NEXT
RETURN nOst

******************************************************
* HDD serial No Detection by Benn Kjaer 
Function GetVolInfo
* 
*** Declare Local Variables ***
LOCAL i			&& counter
LOCAL lnDrvType && DRIVETYPE
LOCAL lcDrive   && string
LOCAL lnDrive   && bitmap of legal drives

* standard declares for WinAPI calls
LOCAL lpRootPathName,  ;
	  lpVolumeNameBuffer,  ;
	  lpVolumeSerialNumber,  ;
	  lpMaximumComponentLength, ;
	  lpFileSystemFlags,  ;
	  lpFileSystemNameBuffer, ;
	  nVolumeNameSize, ;
	  nFileSystemNameSize

*** Declare API calls ***
* GetDriveType() returns numeric type of drive
DECLARE INTEGER GetDriveType IN WIN32API ;
  STRING lpRootPathName && address of root path 
* GetLogicalDrives() returns a bitmap of 
* "legal" logical drives
DECLARE INTEGER GetLogicalDrives in win32api

* GetVolumeInformation() returns volume names, ;
  serial numbers, file systems, and other stuff.
  
DECLARE short GetVolumeInformation IN Win32API ;
    STRING  lpRootPathName,  ;
    STRING  lpVolumeNameBuffer,  ;
   INTEGER  nVolumeNameSize,  ;
    STRING  lpVolumeSerialNumber,     ;
    STRING  lpMaximumComponentLength, ;
    STRING  lpFileSystemFlags,  ;
    STRING  lpFileSystemNameBuffer,  ;
   INTEGER  nFileSystemNameSize 

* GetDriveType RETURN VALUES:
#DEFINE DRIVE_NONE      0 && Cannot be determined.
#DEFINE DRIVE_BAD       1 && Root directory does not exist.
#DEFINE DRIVE_REMOVABLE 2 && Disk can be removed.
#DEFINE DRIVE_FIXED     3 && Disk cannot be removed.
#DEFINE DRIVE_REMOTE    4 && Drive is remote/network drive.
#DEFINE DRIVE_CDROM     5 && The drive is a CD-ROM drive.
#DEFINE DRIVE_RAMDISK   6 && The drive is a RAM disk.

*** Get bitmap of legal drives ***
lnDrive = GetLogicalDrives()
    lcDrive = CHR(ASC("A")+2)+":\" && translate to letter (C:)
    * Set the defaults for floppies
    lpVolumeNameBuffer = ""
    lnDriveType = DRIVE_REMOVABLE
    * Skip trying to obtain the name or drive type of 
    * floppies: this can bring up an untrappable error
      * Obtain the Volume Name
      STORE SPACE(255) TO lpRootPathName,  ;
                          lpVolumeNameBuffer,  ;
                          lpVolumeSerialNumber,  ;
                          lpMaximumComponentLength, ;
                          lpFileSystemFlags,  ;
                          lpFileSystemNameBuffer
      STORE 255 TO nVolumeNameSize, nFileSystemNameSize
      = GetVolumeInformation(lcDrive, ;
                             @lpVolumeNameBuffer, ;
                             @nVolumeNameSize, ;
                             @lpVolumeSerialNumber,  ;
                             @lpMaximumComponentLength, ;
                             @lpFileSystemFlags,  ;
                             @lpFileSystemNameBuffer,  ;
                             @nFileSystemNameSize )
      * Truncate the buffer to the CHR(0) end of string
      * or to zero for blank volumes
      lpVolumeNameBuffer = LEFT(lpVolumeNameBuffer, ;
                           AT(CHR(0),lpVolumeNameBuffer)-1)
      * Get the volume's drive type
      lnDriveType = GetDriveType(lcDrive)
	cReturnHex = ""
	FOR y = 1 TO LEN(ALLTRIM(lpVolumeSerialNumber))
		cStreng = SUBSTR(lpVolumeSerialNumber,y,1)
		cBin = Dec2Bin(ASC(cStreng))
		cHex = Bin2Hex(cBin)
		IF LEN(cHex) = 1
			cHex = "0" + cHex
		ENDIF
		cReturnHex = cHex + cReturnHex
	ENDFOR y
RETURN cReturnHex

* Function Bin2Hex
* Function to convert BIN to HEX
FUNCTION Bin2Hex
PARAMETERS cBin
PRIVATE nBinLen, nZeroLen, cHexValue, nLoopX, cBit, cHex
	nBinLen = LEN(cBin)
	nZeroLag = ROUND((nBinLen/4)+.49,0)*4 - nBinLen
	cBin = REPLICATE("0",nZeroLag)+cBin
	cHexValue = ""
	FOR nLoopX = 1 TO LEN(cBin) STEP 4
		cBit = SUBSTR(cBin,nLoopX,4)
		DO CASE
			CASE cBit = "0000"
				cHex = "0"
			CASE cBit = "0001"
				cHex = "1"
			CASE cBit = "0010"
				cHex = "2"
			CASE cBit = "0011"
				cHex = "3"
			CASE cBit = "0100"
				cHex = "4"
			CASE cBit = "0101"
				cHex = "5"
			CASE cBit = "0110"
				cHex = "6"
			CASE cBit = "0111"
				cHex = "7"
			CASE cBit = "1000"
				cHex = "8"
			CASE cBit = "1001"
				cHex = "9"
			CASE cBit = "1010"
				cHex = "A"
			CASE cBit = "1011"
				cHex = "B"
			CASE cBit = "1100"
				cHex = "C"
			CASE cBit = "1101"
				cHex = "D"
			CASE cBit = "1110"
				cHex = "E"
			CASE cBit = "1111"
				cHex = "F"
		ENDCASE
		cHexValue = cHexValue + cHex
	NEXT
RETURN cHexValue
* End of Function * Bin2Hex() *

* Function Dec2Bin
* Function to convert Decimal to BIN
FUNCTION Dec2Bin
PARAMETERS nValue
PRIVATE nValue, cBinStr, nRest
	cBinStr = ""
	DO WHILE .T.
		nRest = MOD(nValue,2)
		nValue = INT(nValue/2)
		cBinStr = STR(nRest,1) + cBinStr
		IF nValue = 0
			EXIT
		ENDIF
	ENDDO
RETURN cBinStr
* End of Function * Dec2Bin() *
* End of HDD serial No Detection functions by Benn Kjaer

***************** End of GUID functions *********************************************